function dot= Lin_Steering(wdcom,we,delta)  
global J m ref quad hcmg d2r r2d wcmg zeta kr
%
% State Variables (x)
% x(1-3)  = Jerk Limiter
% we(3)   = Vehicle rate error
% delta(4)= Gimbal angles

dot= zeros(4,1);                                         % 7 outputs

for i=1:4
    A(:,i)=(-sin(delta(i))*ref(:,i) + cos(delta(i))*quad(:,i))*hcmg(i);
end
wdot= kr*we;                                             % rate error
hdot = J*wdot; 
pinverse= A'*inv(A*A');
dot(1:4)= -pinverse*hdot;                            % Delta dot command
