label='90 deg maneuver about axis [0.8, -0.8, 0.4]';
%------------------------------------------
figure (1)
SUBPLOT(2,2,1), plot(time,wb*r2d, 'LineWidth',1.5); grid ON
Title(label); 
ylabel('body rates (deg/s)')

SUBPLOT(2,2,3), plot(time,Hcmg, 'LineWidth',1.5); grid ON
ylabel('CMG Mom Body (ft-lb-s)')
xlabel('Time')

SUBPLOT(2,2,2), plot(time,deld*r2d, 'LineWidth',1.5); grid ON
ylabel('Gimbal Rates (deg/s)')

SUBPLOT(2,2,4), plot(time,deldd*r2d, 'LineWidth',1.5); grid ON
ylabel('Gimbal Accels (deg/s^2)')
xlabel('Time')
%------------------------------------------
figure (2)
SUBPLOT(2,2,2), plot(time,theta, 'LineWidth',1.5); grid ON
Title(label)
ylabel('Vehicle rotation (deg)')
xlabel('Time')

SUBPLOT(2,2,1), plot(-qe, wb*r2d, 'LineWidth',1.5); grid ON
xlabel('Attit Error (deg)')
ylabel('Rate Error (deg/s)')

SUBPLOT(2,2,3), plot(time,exis,'LineWidth',1.5); grid ON
legend('Roll','Pitch','Yaw');
ylabel('Rotation Eigenaxis')
xlabel('Time')

[n1,n2]=size(qe); q1=zeros(n1,1);
for i=1:n1; q1(i)= norm(qe(i,:)); end
SUBPLOT(2,2,4), semilogy(time,q1(1:n1),'b', 'LineWidth',1.5); GRID ON
AXIS([0 max(time) 1.0e-10 1.0e+2])
ylabel('Attitude Error (deg)')
xlabel('Time')
%------------------------------------------
figure (3)
SUBPLOT(2,2,3), plot(time, delta*r2d, 'LineWidth',1.5); grid ON
ylabel('Gimbal Angle (deg/s)')
xlabel('Time')

SUBPLOT(2,2,4), plot(time,Tcmg,'LineWidth',1.5)
ylabel('CMG Control Torque (ft-lb)')
legend('Roll','Pitch','Yaw');
xlabel('Time')

SUBPLOT(2,2,2), plot(time, deld*r2d, 'LineWidth',1.5); grid ON
ylabel('Gimbal Rate (deg/s)')
xlabel('Time')

SUBPLOT(2,2,1), plot(delta*r2d, deld*r2d, 'LineWidth',1.5); grid ON
Title(label)
xlabel('Gimbal Angle (deg)')
ylabel('Gimbal Rate (deg/s)')
%---------------------------------------------------------
figure (4)
SUBPLOT(2,2,1), plot(time,det, 'LineWidth',1.5)
Title(label)
ylabel('det(A*A^{T})')

SUBPLOT(2,2,3), plot(time,kay, 'LineWidth',1.5)
ylabel('kay')
xlabel('Time')

[n1,n2]=size(Hsys); q1=zeros(n1,1);
for i=1:n1; q1(i)= norm(Hsys(i,:)); end
SUBPLOT(2,2,2), plot(time,Hsys, time,q1,'m','LineWidth',1.5)
legend('Roll','Pitch','Yaw', 'Magn');
ylabel('Syst Moment, (ft-lb-sec)')
xlabel('Time')
%---------------------------------------------------------