global J Jinv m ref quad hcmg d2r r2d wcmg zeta Igi
global Acc_Lim Rat_Lim kr ki kp Es Ps Fs wlim mx

d2r= pi/180; r2d=180/pi;
J= [0.175972E+4, -0.16151e+3,  0.1187E+2;          % Vehicle MOI matrix in (slug-ft^2).
   -0.16151e+3,   1.30452E+4,  0.3103E+2;
    0.1187E+2,    0.3103E+2,   1.410986E+4];
Jinv= inv(J);

Tc2b= [0, 0, 1; ...                                % Transformation Matrix
       0, 1, 0; ...                                % from CMG to Body Axis
      -1, 0, 0];
hcmg=[1000, 1000, 1000, 1000];                     % CMG Momentum capability
h= [0 0 0 0]';                                     % s/c Initial Momentum
[m, ref, quad]= M4(55);                            % CMG Gimbal, Spin, & Torq direction matrices
m=Tc2b*m; ref=Tc2b*ref; quad=Tc2b*quad;            % Convert matrices to body axes
sigma0=[0; 0; 0; 0]*d2r;                           % Initial CMG Gimbal positions (rad)
wb0= [0; 0; 0];                                    % Initial body rates
Qt_in=[0; 0; 0; 1];                                % Initial Quaternion
ini= [wb0',Qt_in'];                                % State Integrator Initialization
wcmg= 80; zeta= 0.82;                              % CMG bandwidth (rad/s), damping coeff
wlim= 5.4*d2r;                                     % MaxEn ACS Rate Limit 3.9 (deg/s)
Tmax= 800;                                         % Max CMG Torque
mx= Tmax*[1,1,1]./[J(1,1),J(2,2),J(3,3)];          % Max accelerations x,y,z
Acc_Lim=16*d2r; Rat_Lim=12*d2r;                    % Steering Law Accel & Rate limit 40,10 (deg/sec)
Aclim=2500*d2r; Wclim=80*d2r;                      % CMG Model Gimbal Accelerat and Rate Limits
ki=0.17; kp=8.0; kr=13;                            % PID Gains: ki=0.3; kp=7.3; kr=12
Es=0.05; Ps=1.0e12; Fs=0.2;                        % Singul Avoid Param Es=0.01 Ps=1.0e11 Fs=0.2

com_dir=[0.8; -0.8; 0.4];                          % Command Direction Unit Vector
com_dir=com_dir/sqrt(com_dir'*com_dir);            % Unit Vector [0.7; -0.6; 0.4]

