label='100 deg maneuver in [0.2, -0.4, 0.6] direction, 4 SGCMG Control';
%------------------------------------------
figure (1)
SUBPLOT(2,2,1), plot(time,theta, 'LineWidth',1.5); grid ON
Title(label)
ylabel('vehicle rotation (deg)')
xlabel('Time')

SUBPLOT(2,2,2), plot(time,exis,'LineWidth',1.5); grid ON
ylabel('Rotation Eigenaxis')
xlabel('Time')

[n1,n2]=size(qe); q1=zeros(n1,1);
for i=1:n1; q1(i)= norm(qe(i,:)); end
SUBPLOT(2,2,3), semilogy(time,q1(1:n1),'b', 'LineWidth',1.5); GRID ON
AXIS([0 max(time) 1.0e-9 1.0e+3])
ylabel('Attitude Error (deg)')
xlabel('Time')

SUBPLOT(2,2,4), plot(-qe, wb*r2d, 'LineWidth',1.5)
ylabel('Rate Error (deg/s)')
xlabel('Time')
%------------------------------------------
figure (2)
SUBPLOT(2,2,1), plot(time,Hcmg, 'LineWidth',1.5)
Title(label)
grid ON
ylabel('CMG Momentum in Body (ft-lb-sec)')
xlabel('Time')

SUBPLOT(2,2,2), plot(time,Tcmg,'LineWidth',1.5); grid ON
legend('Roll','Pitch','Yaw');
ylabel('CMG Control Torque (ft-lb)')
xlabel('Time')

[n1,n2]=size(Hsys); q1=zeros(n1,1);
for i=1:n1; q1(i)= norm(Hsys(i,:)); end
SUBPLOT(2,2,4), plot(time,Hsys, time,q1,'m','LineWidth',1.5)
legend('Roll','Pitch','Yaw', 'Magnitude');
ylabel('System Momentum, (ft-lb-sec)')
xlabel('Time')

SUBPLOT(2,2,3), plot(time,wb*r2d, 'LineWidth',1.5); grid ON
ylabel('body rates (deg/s)')
xlabel('Time')
%------------------------------------------
figure (3)
SUBPLOT(2,2,1), plot(-qe, wb*r2d, 'LineWidth',1.5); grid ON
Title(label)
ylabel('Rate Error (deg/s)')
xlabel('Time')

SUBPLOT(2,2,2), plot(delta*r2d, deld*r2d, 'LineWidth',1.5); grid ON
xlabel('Gimbal Angle (deg)')
ylabel('Gimbal Rate (deg/s)')

SUBPLOT(2,2,3), plot(time,det, 'LineWidth',1.5)
ylabel('det(A*A^{T})')
xlabel('Time')

SUBPLOT(2,2,4), plot(time,kay, 'LineWidth',1.5)
ylabel('kay')
xlabel('Time')
%------------------------------------------
