global J Jinv m ref quad hcmg d2r r2d wcmg zeta
global Acc_Lim Rat_Lim kr ki kp Es Ps Fs wlim mx
global bet gam Jgi Jsi Joi 

d2r= pi/180; r2d=180/pi;
J= [0.175972E+4, -0.16151e+3,  0.1187E+2;          % Vehicle MOI matrix in (slug-ft^2).
   -0.16151e+3,   1.30452E+4,  0.3103E+2;
    0.1187E+2,    0.3103E+2,   1.410986E+4];
Tc2b= [0, 0, 1; ...                                % Transformation Matrix
       0, 1, 0; ...                                % from CMG to Body Axis
      -1, 0, 0]; Tb2c= inv(Tc2b);
J= Tb2c*J*Tc2b;                                    % Convert Inertias to CMG axes
Jinv= inv(J);

Jsi= 1.2; Jgi= 0.6; Joi= 0.8;                      % CMG Inertia about Spin, Gimbal, Outp axes
wcmg=400; zeta= 0.95; lamb=0.5;                    % CMG servo bandwidth (rad/s), damping coeff
Kii=lamb*Jgi*wcmg^3;                               % CMG Servo Gains
Ka=(1+2*zeta*lamb)*Jgi*wcmg^2; 
Kb=(2*zeta+lamb)*wcmg/Ka;   
hcmg=[1, 1, 1, 1]*1200;                            % CMG Momentum capability

% CMG Geometry
bet=68;                                            % Pyramid Beta angle
gam=[90, 180, 270, 0];                             % Pyramid Gamma angles
[m, ref, quad]= M4(bet);                           % CMG Gimbal, Spin, & Torq direction matrices

sigma0=[0; 0; 0; 0]*d2r;                           % Initial CMG Gimbal positions (rad)
wb0= [0; 0; 0];                                    % Initial body rates
h0= [0; 0; 0];                                     % Initial CMG Momentum (body)
deldot= [0 0 0 0]';                                % Initial Gimb Rates
delta = [0 0 0 0]';                                % Initial Gimb Angles
Qt0=[0; 0; 0; 1];                                  % Initial Quaternion
ini= [wb0',h0',deldot',delta',Qt0'];               % State Integrator Initialization
wlim= 3.6*d2r;                                     % MaxEn ACS Rate Limit 3.9 (deg/s)
Tmax= 650;                                         % Max CMG Torque
mx= Tmax*[1,1,1]./[J(3,3),J(2,2),J(3,3)];          % Max accelerations x,y,z
Acc_Lim=30*d2r; Rat_Lim=12*d2r;                    % Steering Law Accel & Rate limit 40,10 (deg/sec)
Tglim=80; Wclim=80*d2r;                            % CMG Model Gimbal Accelerat and Rate Limits
ki=0.17; kp=8.0; kr=13;                            % PID Gains: ki=0.3; kp=7.3; kr=12
Es=0.05; Ps=1.0e18; Fs=0.2;                        % Singul Avoid Param Es=0.01 Ps=1.0e11 Fs=0.2
xlim= inf(1,18); xlim(7:10)=Wclim*[1 1 1 1];       % State Integrator Limits

com_dir=Tb2c*[0.4; -0.4; -0.4];                    % Command Direction Unit Vector
com_dir=com_dir/sqrt(com_dir'*com_dir);            % Unit Vector [0.7; -0.6; 0.4]

