function dot= ACS_Lin(x,qe)                   
% PID Attitude Controller 
% -------------------------------------------------------
% State Variables (x)
% x(1-3)  = Position Integration
% dot(6:8) = wc (veloc command)
% dot(9:11)= qe (attitude error)
% -------------------------------------------------------

dot= zeros(11,1);                                  % 11 outputs
ki=0.08; kp=3.0; ki2=0.012; kp2=0.3;               % PI Gains (0.04, 2.4), (0.01; 0.3)
q1=qe(1); qq=qe(2:3);                              % Split [pitch,yaw] and [roll]
dot(1) = ki2*q1;                                   % Roll Position Integration
wccc(1)= kp2*q1 + x(1);                            % PI controller (x)

dot(2:3) = ki*qq;                                  % Pitch/Yaw Position Integrat
wccc(2:3)= kp*qq + x(2:3);                         % PI controller (y,z)

dot(4:5)= [0, 0]';
dot(6:8)= wccc;
dot(9:11)= [0,0,0]';