label='2 SGCMG & 1 RW with Flex, 40 deg maneuver in direct: [0, 0.5, -1]';
%------------------------------------------
figure (1)
SUBPLOT(2,2,1), plot(time,theta, 'LineWidth',1.5); grid ON
Title(label)
ylabel('Vehicle Rotation (deg)')

SUBPLOT(2,2,2), plot(time,exis,'LineWidth',1.5); grid ON
ylabel('Rotation Eigenaxis')
xlabel('Time')

[n1,n2]=size(qe); q3=zeros(n1,2);
for i=1:n1; 
    q1(i)= norm(qe(i,1));
    q2(i)= norm(qe(i,[2:3])); 
end
SUBPLOT(2,2,3), semilogy(time,q1(1:n1)*2*r2d,'b', time,q2(1:n1)*2*r2d,'r'); 
GRID ON
AXIS([0 max(time) 1.0e-6 1.0e+2])
legend('Roll','Pitch/Yaw');
ylabel('Attitude Error (deg)')
xlabel('Time')

q3=zeros(n1,3);
for i=1:n1; 
    q2(i)= norm(qe(i,:));            % attit error magnit
    alf(i)=2*r2d*asin(q2(i));        % attit error in deg
    q3(i,:)=alf(i)*qe(i,:)/q2(i);    % back in vector form
end
SUBPLOT(2,2,4), plot(-q3, wb*r2d, 'LineWidth',1.5); grid ON
ylabel('Rate Error (deg/s)')
xlabel('Attitude Error (deg)')
%------------------------------------------
figure (2)
SUBPLOT(2,2,2), plot(time,wb*r2d, 'LineWidth',1.5); grid ON
Title(label)
ylabel('Vehi Body Rates (deg/s)')

SUBPLOT(2,2,1), plot(time,wc*r2d, 'LineWidth',1.5); grid ON
ylabel('Body Rate Comd (deg/s)')

SUBPLOT(2,2,3), plot(time,wr*60/(2*pi), 'LineWidth',1.5); grid ON
ylabel('React-Wheel Rate (rpm)')
xlabel('Time')

SUBPLOT(2,2,4), plot(time,Twc, 'LineWidth',1.5)
ylabel('RW Torque (ft-lb)')
xlabel('Time')
%------------------------------------------
figure (3)
SUBPLOT(2,2,1), plot(time,Hcmg, 'LineWidth',1.5); grid ON
Title(label)
ylabel('CMG Moment. in body (ft-lb-s)')

SUBPLOT(2,2,2), plot(time,Tci,'LineWidth',1.5); grid ON
legend('G#1 ptch','G#2 yaw');
ylabel('CMG Gimbal Torque (ft-lb)')

SUBPLOT(2,2,3), plot(time,Tmcs,'LineWidth',1.5); grid ON
Title('Momentum Control System Output Torque')
ylabel('MCS Control Torq (ft-lb)')
legend('Roll','Pitch','Yaw');
xlabel('Time')

[n1,n2]=size(Hsys); q1=zeros(n1,1);
for i=1:n1; q1(i)= norm(Hsys(i,:)); end
SUBPLOT(2,2,4), plot(time,Hsys, time,q1,'m')
legend('Roll','Pitch','Yaw', 'Magnitude');
ylabel('Sys Moment. Magn (ft-lb-s)')
xlabel('Time')
%------------------------------------------
figure (4)
SUBPLOT(2,2,1), plot(time, delta*r2d, 'LineWidth',1.5); grid ON
Title(label)
ylabel('Gimbal Angle (deg)')

SUBPLOT(2,2,2), plot(time, deld*r2d, 'LineWidth',1.5); grid ON
ylabel('Gimbal Rate (deg/s)')
legend('Gimb #1, Pitch','Gimb #2, Yaw');

SUBPLOT(2,2,3), plot(time,deldd*r2d, 'LineWidth',1.5); grid ON
ylabel('Gimbal Accel (deg/s^2)')
xlabel('Time')

SUBPLOT(2,2,4), plot(time,Tci, 'LineWidth',1.5); grid ON
ylabel('Gimbal Torque (ft-lb)')
legend('Gimb #1, Pitch','Gimb #2, Yaw');
xlabel('Time')
%------------------------------------------
figure (5)
[n1,n2]=size(qe); q3=zeros(n1,2);
for i=1:n1; 
    q1(i)= norm(qe(i,1));
    q2(i)= norm(qe(i,[2:3])); 
end
SUBPLOT(2,2,1), semilogy(time,q1(1:n1)*2*r2d,'b', time,q2(1:n1)*2*r2d,'r'); 
GRID ON
AXIS([0 max(time) 1.0e-6 1.0e+2])
legend('Roll','Pitch/Yaw');
ylabel('Attitude Error (deg)')

SUBPLOT(2,2,3), plot(time,det, 'LineWidth',1.5)
ylabel('det(A*A^{T})')
xlabel('Time')

SUBPLOT(2,2,4), plot(time,kay, 'LineWidth',1.5)
ylabel('kay')
xlabel('Time')
%------------------------------------------