function out= Steering_Lin(wb,wbc,delta,t,wr)           
global m ref quad wcmg d2r r2d
global J Jinv Ix Iy Iz Iw hcmg

% Inputs:
% wb(3)   = Body rates
% wbc(3)  = Body rate commands
% delta(2)= Gimbal angles

krc= 5.2; krw=2.5;                                  % CMG, RW rate gains 4.6, 1.2
out= zeros(7,1); h= [0 0 0]';                       % 6 outputs
we = wbc-wb;                                        % Rate error
wdot1= krw*we(1);   wdmg1=abs(wdot1);               % RW  Accelerat Command
wdot2= krc*we(2:3); wdotmag=sqrt(wdot2'*wdot2);     % CMG Accelerat Command

for i=1:2
    A(:,i)=(-sin(delta(i))*ref(:,i) + cos(delta(i))*quad(:,i))*hcmg(i);
    h = h + (cos(delta(i))*ref(:,i) + sin(delta(i))*quad(:,i))*hcmg(i);
end

pinverse= inv(A'*A)*A';
hdot = J*[0;wdot2];                                 % Desired torque in y,z
deldot= -pinverse*(hdot);                           % Delta dot command
out(1)= (Ix*wdot1);                                 % R-Wheel Torque command
out(2:3)= deldot;
out(4:6)= h;
out(7)= 0;