function [Pj,thd,phd,ddd]= Transforms(del,wb)
global bet gam nc d2r
% To resolve the s/c rates (wb) along (ref,quad,gimb) axes
% bet(nc) is the beta   angle (deg)
% gam(nc) is the gamma  angle (deg)
% del(nc) is the gimbal angle (deg)
% nc is the number of SG-CMGs
% wb(3) is the spacecraft body rate (rad/sec)

b=bet*d2r; g=gam*d2r; d=del*d2r;         % Convert to radians
wx=wb(1);  wy=wb(2);  wz=wb(3);          % Rates in s/c axes

for i=1:nc
    sb=sin(b(i)); cb=cos(b(i)); 
    sg=sin(g(i)); cg=cos(g(i)); 
    sd=sin(d(i)); cd=cos(d(i)); 
    P= [sb*sg, -sd*cg-cd*cb*sg, cd*cg-sd*cb*sg; ...
       -sb*cg, -sd*sg+cd*cb*cg, cd*sg+sd*cb*cg; ...
        cb,     cd*sb,          sd*sb];
    Pj(:,:,i)=P;

    thd(i)= wx*cg + wy*sg;               % theta_dot
    phd(i)=-wx*cb*sg + wy*cb*cg + wz*sb; % phi_dot
    ddd(i)= wx*sb*sg - wy*sb*cg + wz*cb; % delta_dot_inrt - delta_dot_rel
end
