global m ref quad wcmg zeta bet gam nc d2r r2d
global J Jinv Ix Iy Iz Iw Jsi Jgi Joi hcmg 
global Hmax Tmax Alim Jlim maxvel maxvl1 Aclim Wclim
d2r= pi/180; r2d= 180/pi;
[Af, Bf, Cf, Df] = flex_only_fem_s;                % Load Flex Only Spacecr Dynamics
[As, Bs, Cs, Ds] = sc_cmg_rw_rb;                   % Load Rigd s/c from FVP State-Space
[Afs,Bfs,Cfs,Dfs]= sc_cmg_rw_flex;                 % Load Flex s/c from FVP State-Space
Ctr= [0 1 0; 1 0 0; 0 0 -1];                       % Appendage Transform Matric

J= [0.175972E+4, -0.16151e+3,  0.1187E+2;          % Vehicle MOI matrix in (slug-ft^2).
   -0.16151e+3,   1.30452E+4,  0.3103E+2;
    0.1187E+2,    0.3103E+2,   1.410986E+4];
Jinv=inv(J); Ix=J(1,1); Iy=J(2,2); Iz=J(3,3);

% CMG data
m =  [0   0;                                       % CMG Gimbal Directions
      1   0;                                       % Pitch Gimbal
      0   1];                                      % Yaw Gimbal
  
ref= [1  -1;                                       % CMG Init Momentum Directions
      0   0;                                       % Initially spin vectors are ...
      0   0];                                      % in roll direction back to back
  
for i=1:2; 
    quad(:,i)=cross(m(:,i),ref(:,i));              % 3rd Orthogonal axis
end

bet= [-90,0]'; gam=[0,-180]; nc=2;                 % CMG mounting angles
wc=200; z= 0.98; lamb=0.4;                         % CMG servo bandwidth (rad/s), damping coeff
Jsi= 1.2; Jgi= 0.6; Joi= 0.8;                      % CMG Inertia about Spin, Gimbal, Outp axes
Kii=lamb*Jgi*wc^3;                                 % CMG Servo Gains
Ka=(1+2*z*lamb)*Jgi*wc^2; 
Kb=(2*z+lamb)*wc/Ka;   
ki=0.08; kp=3.0; ki2=0.012; kp2=0.3;               % PI Gains (0.04, 2.4), (0.01; 0.3)

% RW data
Hm= 350;                                           % RW Momentum 150 (ft-lb-sec)
Wm= 3500*2*pi/60;                                  % Max RW Speed 2500*2*pi/60 (rad/sec)
Iw= Hm/Wm;                                         % Wheel rotor inertia from 4=Iw*Wmax
Twmax=10;                                          % Max R-Wheel Torque

% Initialization data
wb0= [0  0  0]*d2r;                                % Initial body rates
Qt0= [0  0  0  1];                                 % Initial Quaternion
h0 = [0  0  0];                                    % Initial CMG Momentum (body)
hrw0=[0  0  0];                                    % Initial React-Wheel Momentum
deldot0= [0 0]*d2r;                                % Initial Gimb Rates
delta0 = [0 0]*d2r;                                % Initial Gimb Angles
wr0=0;                                             % Initial RW rate
ini = [wb0,Qt0,h0,hrw0,deldot0,delta0];            % State Integrator Initialization
ini2= [wb0,Qt0,wr0];                               % Old Sim Initialization

Tglim=110;                                         % Max Gimbal Torque
Aclim=200*d2r; Wclim=60*d2r;                       % CMG Model Gimbal Acceler/Rate Limits 
Alim= 0.022; Jlim=120*d2r;                         % Max Steering Accel 0.024 (rad/s^2)
maxvel=0.04; maxvl1=0.025;                         % ACS Veloc limits 0.12, 0.025 (rad/sec)
Tmax=240;                                          % Max Torque 300
Hmax=1200; hcmg=[Hmax, Hmax];                      % Max CMG Momentum, Momentum Array 
wcmg= 80; zeta= 0.9;                               % CMG bandwidth (rad/s), damping coeff

com_dir=[0; 1; 1];                            % Command Direction Unit Vector
com_dir=com_dir/sqrt(com_dir'*com_dir);