function dot= Lin_Steering(wcmd,wb,we,t,delta)  
global J ref quad hcmg kr
%
% State Variables (x)
% x(1-3)  = Jerk Limiter
% we(3)   = Vehicle rate error
% delta(4)= Gimbal angles

dot= zeros(11,1);                                         % 7 outputs
h= [0 0 0]';                                             % CMG Momentum
for i=1:4
    A(:,i)=(-sin(delta(i))*ref(:,i) + cos(delta(i))*quad(:,i))*hcmg(i);
    h = h + (cos(delta(i))*ref(:,i) + sin(delta(i))*quad(:,i))*hcmg(i);
end
wdot= kr*we;                                             % rate error

hdot= J*wdot; dot(2)= sqrt(hdot'*hdot);                  % Control torque

pinverse= A'*inv(A*A');
dot(4:7)= -pinverse*(hdot-cross(wb,h));                  % Delta dot command
dot(8:11)=-pinverse*(hdot); 