% Linear Analysis
start
[Ao,Bo,Co,Do]=linmod('Open_Loop');                 % Open-Loop Analysis Model
syso=SS(Ao,Bo,Co,Do);                              % for Stability analysis
w=logspace(-2,4,18000); 

figure(2); Bode(syso,w); grid on
figure(3); Nichols(syso,w)

%[Ac,Bc,Cc,Dc]=linmod('Closed_Loop');               % Closed-Loop Sensitivity Model
%sysc=SS(Ac,Bc,Cc,Dc);                              % for Stability analysis
%figure(1); Sigma(sysc,w); grid on

w=logspace(-3,3,300);                           % and Frequ domain analysis
npv=61;                                         % Number of Param Variations

[Acl,Bcl,Ccl,Dcl]=linmod('Robust_Anal'); sys=ss(Acl,Bcl,Ccl,Dcl);
mu=ssv(Acl,Bcl,Ccl,Dcl,w);
figure(13); loglog(w,mu);

[Acl,Bcl,Ccl,Dcl]=linmod('Robust_Anal'); sys=ss(Acl,Bcl,Ccl,Dcl);
sysf= FRD(sys,w);
blk=[-ones(npv,1), zeros(npv,1)];
[bnd,muinfo]= mussv(sysf,blk);

ff= get(muinfo.bnds, 'frequency');
muu=get(muinfo.bnds, 'responsedata');
muu=squeeze(muu);
muu=muu(1,:);
figure(14); loglog(ff,muu)
xlabel('Frequency (rad/sec)')
ylabel('ssv')