function out= Phase_Plane(Raterrf,Atterrf,Tfuel0)
global nt r2d Thr Jloc Jdir Ts
global ang_acl att_deadband kledge rate_lim low_rate_lim

rat_err= Raterrf*r2d;
att_err= Atterrf*r2d;
Cnt= [0;0;0];                                          % Control to JetSel

for iax=1:3
    sign_rat_err= sign(rat_err(iax)+1.0e-8);
    x1 = sign_rat_err*att_err(iax);
    x2 = abs(rat_err(iax));
    ang_acl_gain= 2*ang_acl(iax);
    curve = rat_err(iax)^2/ang_acl_gain;
    
    sw1= -curve + att_deadband(iax);
    sw2= -(curve + (kledge(iax)*att_deadband(iax)));
    sw3= rate_lim(iax);
    sw5= low_rate_lim(iax);
    
    if (x1>sw1) | (x2>sw3), Cnt(iax)= -sign_rat_err;    % Region 1
    elseif (x1 >= sw2), Cnt(iax)= 0;                    % Region 2
    elseif (x2 < sw5), Cnt(iax)= sign_rat_err;          % Region 3
    else, Cnt(iax)= 0;  
    end
end

% Select Jets
if abs(Cnt)>0, eu= Cnt/sqrt(Cnt'*Cnt);                  % Direction Unit vect
else, eu=Cnt; end
%fp= Jet_Select_dot3(-eu,nt,Thr,Jloc,Jdir);             % Get Thruster Forces
fp= Jet_Select_dot(-eu,nt,Thr,Jloc,Jdir,4);             % Get Thruster Forces

% Calculate Total Fuel
Tothr=0;
for i=1:nt, Tothr=Tothr+fp(i); end
Tfuel2= Tfuel0 + Tothr*Ts;                              % Total fuel
out = [fp; eu; Tfuel2];