function dot= SV_Dynamics(x,f,Ftank,Td)   
% out= SV_Dynamics(x,Tw,f,Td,Worb) 
% State Variables (x)
% x(1:3)  = Body rates   (wb)   (rad/sec)
% x(4:7)  = Quaternion
% f(1:nt) = RCS Forces in (lbf) (row vector)
% Ftank(3)= Forces at the Tank Center
% Td(3) =   Disturbance Torque
global J IJ cg nt Thr Jloc Jdir Ltnk d2r r2d

dot=zeros(7,1);                                   % Initialize
wb= x(1:3);                                       % body rates (rad/sec)
qt= x(4:7);                                       % attitude quaternion

% Thruster Forces and Moments
mr= zeros(3,1); Frcs=mr; 
for i=1:nt 
    ma= (Jloc(:,i)-cg)/12;                        % Jet moment arms (ft)
    mr= mr + f(i)*cross(ma,Jdir(:,i));            % Total RCS Moment (ft-lb)
end
mr = mr - cross(Ftank,Ltnk);                      % Moment due to Sloash Forces

Hsys= J*wb;                                       % System Momentum in body
dot(1:3)= IJ*(mr -cross(wb,Hsys) +Td);            % Vehicle angular acceleration
dot(4:7)= 0.5*[0     wb(3) -wb(2) wb(1);          % Quaternion Rate Update
             -wb(3)  0      wb(1) wb(2);
              wb(2) -wb(1)  0     wb(3);
             -wb(1) -wb(2) -wb(3) 0]*qt;
