function dw= Rotat_PP3(Raterrf,Atterrf)
% Phase-Plane Logic
global Di_vrcs Lo_vrcs Thr nt r2d TS 
global ang_acl att_deadband kledge rate_lim low_rate_lim

eu= abs(Atterrf/sqrt(Atterrf'*Atterrf));
att_err= Atterrf*r2d;
rat_err= Raterrf*r2d;
Cnt= [0;0;0];                                           % Control to JetSel

for iax=1:3
    sign_rat_err= sign(rat_err(iax)+1.0e-8);
    x1 = sign_rat_err*att_err(iax);
    x2 = abs(rat_err(iax));
    curve = rat_err(iax)^2/(2*ang_acl(iax));
    
    sw1= -curve + att_deadband(iax);
    sw2= -(curve + (kledge(iax)*att_deadband(iax)));
    sw3= rate_lim(iax);
    sw5= low_rate_lim(iax);
    
    if (x1>sw1) | (x2>sw3), Cnt(iax)= -sign_rat_err;    % Region 1
    elseif (x1 >= sw2),     Cnt(iax)= 0;                % Region 2
    elseif (x2 <  sw5),     Cnt(iax)=  sign_rat_err;    % Region 3
    else, Cnt(iax)= 0;  
    end
end
dw=Cnt;
