function [Isel,sf]= Jet_Select_transl(eu,Imax)
% [Isel,sf]= Jet_Select_transl(eu,Imax)
% Uses the dot-product method to select up to Imax jets that  
% produce a force in direction (eu)
% Inputs
% eu(3) : Translation error vector
% nt    : number of jets
% cg(3) : CG location
% Outputs
% Isel     : Number of Selected Jets
% sf(i)    : Array of Selected Jet Numbers

global nt Lo_vrcs Di_vrcs Thr Th
if  abs(eu)==0,                                      % Direction should not be zero
    fp=zeros(nt,1); Isel=0; sf=0; mg=fp; return; 
end  
vt= zeros(3,nt); pf= zeros(nt,1); sf=pf;

for i=1:nt; pf(i)= dot(Di_vrcs(:,i),eu); end         % Thrust compont along maneuv direct
f2=pf;
for i=1:(nt/2)
    [mf,sf(i)]=max(f2); f2(sf(i))=0;                 % Identify the strongest half
end
pf= pf/pf(sf(1));                                    % Normlz relative to strongest

% Select Imax jets among the strongest
Isel=1; mg(1)=pf(sf(1));                             % First, select the strongest
for i=1:Imax-1
    if pf(sf(i+1))>0.0;   
        Isel=Isel+1;                                 % Then, choose one more to Imax
        mg(Isel)= pf(sf(i+1));
    end          
end
sf= sf(1:Isel)';
