function dV= Translat_PP(Vel_err,Pos_err)
% Translational Phase-Plane Logic
global lin_accel pos_deadb kledge upr_vel_lim low_vel_lim
dV= [0;0;0];                                           % Coomand to JetSel

for i=1:3
    sign_Vel_err= sign(Vel_err(i)+1.0e-8);
    x1 = sign_Vel_err * Pos_err(i);
    x2 = abs(Vel_err(i));
    curve = Vel_err(i)^2/ (2*lin_accel(i));
    
    sw1= -curve + pos_deadb(i);
    sw2= -(curve + kledge(i)*pos_deadb(i) );
    sw3= upr_vel_lim(i);
    sw5= low_vel_lim(i);
    
    if (x1>sw1) | (x2>sw3), dV(i)= -sign_Vel_err;    % Region 1
    elseif (x1 >= sw2),     dV(i)= 0;                % Region 2
    elseif (x2 <  sw5),     dV(i)=  sign_Vel_err;    % Region 3
    else, dV(i)= 0;  
    end
end
