global nt AI6 A6 AI3 A3 Th Thr Ts Ts2
global pf A2 A21 r2d 
global js vt vti tk
global lin_accel pos_deadb kledge upr_vel_lim low_vel_lim
global ang_acl att_deadband rate_lim low_rate_lim
global Di_vrcs Lo_vrcs cg lni 
d2r=pi/180; r2d=180/pi; nt=12; Ts=0.005; Ts2=20*Ts;
[Af, Bf, Cf, Df]= flex_spacecraft_fvp_s;              % Load Continuous Flex Spacecraft Dynamics
[Az, Bz, Cz, Dz]= flex_spacecraft_fvp_z;              % Load Discrete (Ts) Flex Spacecr Dynamics

J= [0.175972E+4,  0.16151e+3,  0.1187E+2;             % Vehicle MOI matrix in (slug-ft^2).
    0.16151e+3,   1.30452E+4, -0.3103E+2;
    0.1187E+2,   -0.3103E+2,  1.410986E+4]; IJ=inv(J); 
cg=[-176.84, -2.52, 7.44]';                           % CG Location (ft) C1 

Mv=220; 	                                          % Slugs 
Th=2.2;                                               % (lb)
nt=12;                                                % number of thrusters
Thr= Th*ones(1,nt);                                   % Thrusts Vector
Di_vrcs= zeros(3,nt); Lo_vrcs= Di_vrcs; 
tk=zeros(6,1);

% VRCS thrusters directions 
Di_vrcs(:,1)=  [0.01,  -0.92, +0.39]';            % BR-Y+Z     [-0.008402, 0.926676, -0.375768]';    % R3U
Di_vrcs(:,2)=  [0.01,  +0.92, +0.39]';            % BL+Y+Z     [0.005014, -0.927032, -0.374948]';    % L3U
Di_vrcs(:,3)=  [-0.09, -0.84, -0.535]';           % FR-Y-Z     [0.015125,  0.855663,  0.517312]';    % R4D
Di_vrcs(:,4)=  [-0.09, +0.84, -0.535]';           % FL+Y-Z     [0.015442, -0.851717,  0.523774]';    % L4D
Di_vrcs(:,5)=  [-0.08, -0.72, +0.69]';            % FR-Y+Z     [0.032974,  0.727155, -0.685681]';    % R4U
Di_vrcs(:,6)=  [-0.08, +0.72, +0.69]';            % FL+Y+Z     [-0.00158, -0.752079, -0.659071]';    % L4U
Di_vrcs(:,7)=  [-0.99,  0.0,  +0.12]';            % FRAxi-X    [0.973855,  0.000880, -0.227168]';    % R4F
Di_vrcs(:,8)=  [-0.99,  0.0,  +0.12]';            % FLAxi-X    [0.975321,  0.014201, -0.220332]';    % L4F
Di_vrcs(:,9)=  [0.0,  -0.62, -0.78]';             % BR-Y-Z     [0.010515,  0.658633,  0.752390]';    % R3D
Di_vrcs(:,10)= [0.0,  +0.62, -0.78]';             % BL+Y-Z     [0.012191, -0.671702,  0.740721]';    % L3D
Di_vrcs(:,11)= [1.0,   0.0,   0.0]';              % BRAxi+X    [-0.999999, 0.000826, -0.001022]';    % R3A
Di_vrcs(:,12)= [1.0,   0.0,   0.0]';              % BLAxi+X    [-0.999986,-0.000347,  0.005203]';    % L3A

% VRCS thrusters Locations  
Lo_vrcs(:,1)=  [-307.53,  37.04,  8.15]';         % BR-Y+Z     [-305.161,  36.966,   2.8285]';
Lo_vrcs(:,2)=  [-307.53, -37.04,  8.15]';         % BL+Y+Z     [-305.171, -37.117,   2.7649]';
Lo_vrcs(:,3)=  [-25.13,   19.8,   7.15]';         % FR-Y-Z     [-25.349,   17.415,   4.5136]';
Lo_vrcs(:,4)=  [-25.13,  -19.8,   7.15]';         % FL+Y-Z     [-25.246,  -17.38,    4.5088]';
Lo_vrcs(:,5)=  [-17.0,    15.32,  1.51]';         % FR-Y+Z     [-17.1905,  13.4,     3.8892]';
Lo_vrcs(:,6)=  [-17.0,   -15.32,  1.51]';         % FL+Y+Z     [-16.9563, -13.218,   3.8912]';
Lo_vrcs(:,7)=  [-8.04,     2.0,  -4.0]';          % FRAxi-X    [-11.817,    2.032,  -3.9216]';
Lo_vrcs(:,8)=  [-8.04,    -2.0,  -4.0]';          % FLAxi-X    [-11.787,   -2.034,  -3.9305]';
Lo_vrcs(:,9)=  [-302.3,   37.34,  8.59]';         % BR-Y-Z     [-304.189,  34.297,  10.7186]';
Lo_vrcs(:,10)= [-302.3,  -37.34,  8.59]';         % BL+Y-Z     [-304.153, -34.421,  10.6783]';
Lo_vrcs(:,11)= [-322.3,   21.14,  0.051]';        % BRAxi+X    [-321.593,  21.087,  1.05209]';
Lo_vrcs(:,12)= [-322.3,  -21.14,  0.051]';        % BLAxi+X    [-321.503, -21.0806, 0.9984]';

% Translational phase-plane parameters in (deg) 
lin_accel =     [0.01,   0.01,   0.01];           % (feet/sec^2)
pos_deadb =     [0.3,    0.3,    0.3];            % (feet)
kledge =        [1.2,    1.2,    1.2]; 
upr_vel_lim =   [0.5,    0.5,    0.5];            % (feet/sec)
low_vel_lim =   [0.2,    0.2,    0.2];            % (feet/sec)

% Rotational phase-plane parameters in (deg) 
ang_acl =       [0.2,    0.25,   0.26];           %  [0.3,    0.31,   0.32];
att_deadband=   [0.5,    0.5,    0.5]; 
kledge =        [1.2,    1.2,    1.2]; 
rate_lim =      [0.5,    0.5,    0.5];            %  [0.5,    0.5,   0.5]
low_rate_lim =  [0.15,   0.15,   0.15];           %  [0.15,   0.15,  0.15

Namax= 0.636/(0.2*d2r); 

% Select the most dominant thrusters out of all of them
trq= zeros(3,nt); wd=trq; ac=wd; 
for i=1:nt
    ln= (Lo_vrcs(:,i) - cg)/12;                         % Moment arms (ft) 
    trq(:,i)= Thr(i)*cross(ln,Di_vrcs(:,i));            % Torques Matrix from all jets 
    wd(:,i)= IJ*trq(:,i);                               % Angular accelerations
    ac(:,i)= Di_vrcs(:,i)*(Thr(i)/Mv);                  % Linear accelerations 
end
vt = zeros(3,nt);
for i=1:nt
    ln= (Lo_vrcs(:,i) - cg)/12;                         % Moment arms (ft) 
    vt(:,i)= cross(ln,Di_vrcs(:,i));                    % Torques Matrix from all jets 
end
vti= pinv(vt);
A3=wd;      AI3=pinv(A3);                               % Total accelerations 
A6=[wd;ac]; AI6=pinv(A6); 

