function [js,tko]= Jet_select_6dof(wd,ad) 
% compute the thruster force vector (fp) 
% Inputs: 
% wd(3)  : angular acceleration demand
% ad(3)  : linear acceleration demand
% nt     : number of jets
% 
% outputs:
% fp(nt) : Individual Thrusts
% tm(nt) : Thrusters time on
global A2 A2I nt A3 AI3 A6 AI6 Th Ts Ts2
pmin=500000;

[IselR,jsR]= Jet_Select_rotat(wd,3);                                                % Selected Jets and relative magnit for rotat alone
[IselT,jsT]= Jet_Select_transl(ad,3);                                               % Selected Jets and relative magnit for translat alone

tko=zeros(nt,1); js=zeros(6,1);                                                     % Initialize "time-on" and selected jets to zero
Itot= IselR+IselT;
if Itot<3, js=zeros(6,1); tko=js; return; end                                       % Not enough jets, Don't do anything
    
wa=[wd;ad]; 	                                                                    % Angular and Linear Acceleration Demand
tko=zeros(nt,1);                                                                    % Initialize "time-on" values and jet selected to zero

kr=0; kt=0;                                                                         % rotat & transl jet counters
for j=1:3                                                                           % Fill the array jp(i) with the strongest jets
    if kr<IselR, kr=kr+1; jp(kr+kt)=jsR(j); end
    if kt<IselT, kt=kt+1; jp(kr+kt)=jsT(j); end
end
Itot= kr+kt;

for j=1:Itot-1                                                                      % Eliminate Common Jets from the bottom
k=Itot-j+1;
    for i=1:k-1
        if jp(k)==jp(k-i), jp(k)=0; break; end
    end
end

k=0;
for j=1:Itot                                                                        % Eliminate Common Jets from the bottom
    if jp(j)~=0, k=k+1; js(k)=jp(j); end
end
Itot=k;
if Itot<3, js=zeros(6,1); tko=js; return; end                                       % Not enough jets, Don't do anything

jp=js(1:3);                                                                         % Pick the 3 strongest from the dot selects

for l=1:nt                                                                          % Search for the other 3, a total 6 jets
    if (l ~=jp(1) & l ~=jp(2) & l ~=jp(3) )
        jp(4)=l;
        for m=1:nt
            if (m ~=jp(1) & m ~=jp(2) & m ~=jp(3) & m ~=jp(4))
                jp(5)=m;
                for n=1:nt      
                    if (n ~=jp(1) & n ~=jp(2) & n ~=jp(3) & n ~=jp(4) & n ~=jp(5))  % if n NE to the other 5 select  jets
                        jp(6)=n; 	A2=zeros(6);                                    % give it a try as sixth jet
                        for i2=1:6, A2(:,i2)=A6(:,jp(i2)); end                      % extrct coresp cols from accel matrix A6
                        A2I=inv(A2); tk=A2I*wa; pos=1;                              % calculate "on times" for sel. jets
                        for i2=1:6,                                                 % Selected jets should produce ...
                            if tk(i2)<0, pos=-1; break; end;                        % no negative times
                        end
                        lamb=A2I'*[1;1;1;1;1;1]; p=lamb'*wa;                        % p is measure of fuel usage
                        if (pos>0 & p<pmin & p>0)                                   % condition to accept ...
                            js(4)=l; js(5)=m; js(6)=n;                              % a new jets combination 
                            tko=tk; pmin=p;                                         % on times for sel. jets
                        end
                    end
                end
            end
        end
    end
end

% Normalize the "on times" between zero and 0.5 (sec)
tmx=max(tko);                                           % max on-time
if tmx<Ts, tko=zeros(6,1); js=zeros(6,1); return        % don't fire any
elseif tmx>Ts2, tko= tko*Ts2/tmx; end                   % too much demand, scale times down
for i=1:3; if tko(i)<Ts, tko(i)=0; end; end             % avoid too short times
