global J IJ Mv nt r2d d2r Th Thr Ts Ts2 Msl Rsl
global ang_acl att_deadband kledge rate_lim low_rate_lim 
global Di_rcs Lo_rcs MEloc MEdir nt cg lni axm sah Ltnk Th Kr
global AI3 A3
d2r=pi/180; r2d=180/pi; Ts=0.005; Ts2=20*Ts;          % Dual Sampling Rates

J= [0.175972E+4,  0.16151e+3,  0.1187E+2;             % Vehicle MOI matrix in (slug-ft^2).
    0.16151e+3,   1.30452E+4, -0.3103E+2;
    0.1187E+2,   -0.3103E+2,  1.410986E+4]; IJ=inv(J); 
cg=[-176.84, -2.52, 7.44]';                           % CG Location (ft) C1 
axm=[-8.1836,   0,   -1.189]'; axm=axm-cg/12;         % accelerom. nod#2 (feet)
sah=[-9.462,   -2,   -2.09]';  sah=sah-cg/12;         % ant. hinge nod#4 (feet)
Ltnk=[-19.583,  0,    0,]';    Ltnk=Ltnk-cg/12;       % Tank Center Location
Ctr= [0 1 0; 1 0 0; 0 0 -1];                          % Appendage 2Body Transform Matrix
wb0= [0, 0, 0]*d2r;                                   % Initial body rates
V0 = [0, 0, 0];                                       % Initial velocity
qt0= [0, 0, 0, 1];                                    % Initial quaternion
x_ini= [wb0, qt0, V0];                                % State Initialization

Mv=202.4; 	                                          % Slugs 
Th=2.2;                                               % Thrust (lb), Init Fuel
nt=12;                                                % number of thrusters
Thr= Th*ones(1,nt);                                   % Thrusts Vector
Msl= 35;                                              % Slosh Mass (slug)
Rsl= 1.2;                                             % Pendulum Length (feet)
Di_rcs= zeros(3,nt); Lo_rcs= Di_rcs; 
tk=zeros(6,1);

% rcs thrusters directions 
Di_rcs(:,1)=  [0.01,  -0.92, +0.39]';            % BR-Y+Z     [-0.008402, 0.926676, -0.375768]';    
Di_rcs(:,2)=  [0.01,  +0.92, +0.39]';            % BL+Y+Z     [0.005014, -0.927032, -0.374948]';    
Di_rcs(:,3)=  [-0.09, -0.84, -0.535]';           % FR-Y-Z     [0.015125,  0.855663,  0.517312]';    
Di_rcs(:,4)=  [-0.09, +0.84, -0.535]';           % FL+Y-Z     [0.015442, -0.851717,  0.523774]';    
Di_rcs(:,5)=  [-0.08, -0.72, +0.69]';            % FR-Y+Z     [0.032974,  0.727155, -0.685681]';   
Di_rcs(:,6)=  [-0.08, +0.72, +0.69]';            % FL+Y+Z     [-0.00158, -0.752079, -0.659071]';   
Di_rcs(:,7)=  [-0.99,  0.0,  +0.12]';            % FRAxi-X    [0.973855,  0.000880, -0.227168]';   
Di_rcs(:,8)=  [-0.99,  0.0,  +0.12]';            % FLAxi-X    [0.975321,  0.014201, -0.220332]';   
Di_rcs(:,9)=  [0.0,  -0.62, -0.78]';             % BR-Y-Z     [0.010515,  0.658633,  0.752390]';   
Di_rcs(:,10)= [0.0,  +0.62, -0.78]';             % BL+Y-Z     [0.012191, -0.671702,  0.740721]';   
Di_rcs(:,11)= [1.0,   0.0,   0.0]';              % BRAxi+X    [-0.999999, 0.000826, -0.001022]';  
Di_rcs(:,12)= [1.0,   0.0,   0.0]';              % BLAxi+X    [-0.999986,-0.000347,  0.005203]';  
MEdir =       [1.0,   0.0,   0.0]';              % Reboost Engine

% rcs thrusters Locations  
Lo_rcs(:,1)=  [-307.53,  37.04,  8.15]';         % BR-Y+Z     [-305.161,  36.966,   2.8285]';
Lo_rcs(:,2)=  [-307.53, -37.04,  8.15]';         % BL+Y+Z     [-305.171, -37.117,   2.7649]';
Lo_rcs(:,3)=  [-25.13,   19.8,   7.15]';         % FR-Y-Z     [-25.349,   17.415,   4.5136]';
Lo_rcs(:,4)=  [-25.13,  -19.8,   7.15]';         % FL+Y-Z     [-25.246,  -17.38,    4.5088]';
Lo_rcs(:,5)=  [-17.0,    15.32,  1.51]';         % FR-Y+Z     [-17.1905,  13.4,     3.8892]';
Lo_rcs(:,6)=  [-17.0,   -15.32,  1.51]';         % FL+Y+Z     [-16.9563, -13.218,   3.8912]';
Lo_rcs(:,7)=  [-8.04,     2.0,  -4.0]';          % FRAxi-X    [-11.817,    2.032,  -3.9216]';
Lo_rcs(:,8)=  [-8.04,    -2.0,  -4.0]';          % FLAxi-X    [-11.787,   -2.034,  -3.9305]';
Lo_rcs(:,9)=  [-302.3,   37.34,  8.59]';         % BR-Y-Z     [-304.189,  34.297,  10.7186]';
Lo_rcs(:,10)= [-302.3,  -37.34,  8.59]';         % BL+Y-Z     [-304.153, -34.421,  10.6783]';
Lo_rcs(:,11)= [-322.3,   21.14,  0.051]';        % BRAxi+X    [-321.593,  21.087,  1.05209]';
Lo_rcs(:,12)= [-322.3,  -21.14,  0.051]';        % BLAxi+X    [-321.503, -21.0806, 0.9984]';
MEloc =       [-322.6,   -2.0,   6.0]';          % Reboost Engine

% Create the Accelerations and Torques Matrices from each jet
vt= zeros(3,nt); wd=vt; tq=vt; ac=vt; 
for i=1:nt
    ln= (Lo_rcs(:,i) - cg)/12;                         % Moment arms (ft) 
    tq(:,i)= Thr(i)*cross(ln,Di_rcs(:,i));             % Torques Matrix from all jets 
    vt(:,i)= cross(ln,Di_rcs(:,i));                    % Normlz Torqu Matrix all jets 
    wd(:,i)= IJ*tq(:,i);                               % Angular accelerations
    ac(:,i)= Di_rcs(:,i)*(Thr(i)/Mv);                  % Linear accelerations 
end
vti= pinv(vt);
A3=wd;      AI3=pinv(A3);                              % Total accelerations 
A6=[wd;ac]; AI6=pinv(A6); 

% phase-plane parameters in (deg) 
ang_acl =       [0.3,    0.31,   0.32]; 
att_deadband=   [1.0,    1.0,    1.0]; 
kledge =        [1.2,    1.2,    1.2]; 
rate_lim =      [0.5,    0.5,    0.5]; 
low_rate_lim =  [0.15,   0.15,   0.15]; 
