function out= Slosh_Lin(x,Acc) 
% out= Slosh_Lin(x,Acc)  
% Computes the Slosh Forces on the Tank as a function 
% of Vehicle acceleration at the Tank
%
% Acc(3}  = Spacecraft Linear Accelerat at Tank Center (x,y,z)
% Msl     = Slosh Mass (slug)
% Rsl     = Pendulum length (ft)
% Ltnk(3} = Location of the Tank Center
% Ts      = Sampling Period (sec)
% State Variables (x) 
% x(l)= Ys dot                                        % Slosh Mass Veloc along Y
% x(2)=	Ys                                            % Slosh Mass Posit along Y
% x(3)=	Zs dot                                        % Slosh Mass Veloc along Z
% x(4)=	Zs                                            % Slosh Mass Posit along Z
global Msl Rsl


% States 
zet= 0.004;                                           % damping coefficients
Acc(1)=0.5;
Ws2=Acc(1)/Rsl; Ws=sqrt(Ws2);                         % Natuaral Frequency

% Slosh Mass Veloc & Accelerat along y and z 
xd(1)= -Ws2*x(2) -Acc(2) -2*zet*Ws*x(1);              % Ys_dd 
xd(2)=  x(1);                                         % Ys_d
xd(3)= -Ws2*x(4) -Acc(3) -2*zet*Ws*x(3);              % Zs_dd
xd(4)=  x(3);                                         % Zs_d

Fv= Msl*Acc(1)*[-1, x(2)/Rsl, x(4)/Rsl]';             % Force on the Vehicle
out = [xd'; Fv]; 
